% Mixed-Criticality task set Generation
% with LOs under HI mode (ECRTS'16 submission)
% By Zhishan Guo 
% 2016.2

function [U_L,U_H, flag_FAIL] = MCTaskGenerator_WLOHI(Ulo,n,n_H) %n_H = binornd(n,0.5);
flag_FAIL = 0;
% % generation of periods
% T =  2.718282.^(rand(1,n));
% C_L=zeros(1,n);
% C_H=zeros(1,n);

% generation of LO utilization
countMAX = 100;
count =0;
U_L=zeros(1,n);
U_L(1) = 1.01;
while max(U_L(1:n))>1 && count < countMAX
    U_L(1:n) = UUniFast(n, Ulo);
    count = count+1;
end
if count == countMAX
    flag_FAIL = 1;
    return;
end

% generation of HI utilization
count = 0;
U_H=ones(1,n);
for i=1:n_H
    U_H(i) = U_L(i)*(1+rand()); %HI task
end
for i=n_H+1:n
    U_H(i) = U_L(i)*(0.25+0.25*rand()); %LO task
end
if count == countMAX
    flag_FAIL = 1;
    return;
end

% % generation of WCETs
% for i=1:n
%     C_L(i)=U_L(i)*T(i);
%     C_H(i)=U_H(i)*T(i);
% end

